AWSTemplateFormatVersion: 2010-09-09
Description: Launch Standalone FortiAnalyzer-VM in a new VPC
Metadata:
  'AWS::CloudFormation::Interface':
    ParameterGroups:
      - Label:
          default: VPC Configuration
        Parameters:
          - ExistingVPCID
          - VPCCIDR
          - ExistingSubnetID
          - ExistingSubnetCIDR
          - PublicSubnetRouterIP
      - Label:
          default: FortiAnalyzer Instance Configuration
        Parameters:
          - AZForFAZ
          - FAZInstanceType
          - FortiAnalyzerVersion
          - LicenseType
          - CIDRForFAZccess
          - KeyPair
          - EncryptVolumes
      - Label:
          default: Contact
        Parameters:
          - EmailNotification
    ParameterLabels:
      FortiAnalyzerVersion:
        default: FotiAnalyzer Version
Parameters:
  ExistingVPCID:
    Type: AWS::EC2::VPC::Id
    Description: ID of an existing VPC
  ExistingSubnetID:
    Type: AWS::EC2::Subnet::Id
    Description: ID of an existing public subnet
  ExistingSubnetCIDR:
    Type: String
    Default: 10.0.1.0/24
    Description: CIDR block of the existing subnet (e.g., 10.0.1.0/24)
  VPCCIDR:
    Type: String
    Default: 10.0.0.0/16
    Description: Enter the VPC CIDR that you are using
  AZForFAZ:
    Type: 'AWS::EC2::AvailabilityZone::Name'
    Description: Select the AZ for FortiAnalyzer
  PublicSubnetRouterIP:
    Type: String
    Default: 10.0.1.1
    Description: Provide the IP of the gateway for the public subnet
  FAZInstanceType:
    Type: String
    Default: m5.xlarge
    Description: Select the instance type for the FortiAnalyzer
    AllowedValues:
      - m5.xlarge
      - m5.2xlarge
      - m5.4xlarge
      - m5.8xlarge
      - m5.12xlarge
      - m5.16xlarge
      - m5.24xlarge
  FortiAnalyzerVersion:
    Type: String
    Default: 7.6.x
    Description: Select the verion of FortiAnalyzer to use (latest GA AMI will be used)
    AllowedValues:
      - 7.0.x
      - 7.2.x
      - 7.4.x
      - 7.6.x
  LicenseType:
    Type: String
    Description: Select the license type for the FortiAnalyzer
    AllowedValues:
      - BYOL
      - PAYG2Devices
      - PAYG10Devices
      - PAYG30Devices
      - PAYG100Devices
      - PAYG500Devices
  CIDRForFAZccess:
    Type: String
    Default: 0.0.0.0/0
    Description: Enter the CIDR from which FortiAnalzer instance need to be accessed from
  KeyPair:
    Type: 'AWS::EC2::KeyPair::KeyName'
    Description: Select the keypair for the FortiAnalzer
  EncryptVolumes:
    Type: String
    Description: Select 'true' to encrypt the FortiAnalyzer instances OS and Log volumes with your account's KMS default master key for EBS.  Otherwise select false to leave unencrypted
    AllowedValues:
      - 'true'
      - 'false'
  EmailNotification:
    Type: String
    Default: admin@example.com
    Description: >-
      Provide an email address to receive notifications when the CloudWatch Failover Alarm is triggered
Mappings:
  FortiAnalyzerAMISearchString:
    7.0.x:
      BYOL: FortiAnalyzer-VM64-AWS *(7.0.*)*|9ipdy7tpkp24kmfsjgfuymny1
      Flex: FortiAnalyzer-VM64-AWS *(7.0.*)*|9ipdy7tpkp24kmfsjgfuymny1
      PAYG2Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.0.*)*|9dtuu71e8jl604ce11efi1mzo
      PAYG10Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.0.*)*|5fjrlla50pzzq1c8064gnm11n
      PAYG30Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.0.*)*|f260v7j9fwdvlcsbnpsjpaozc
      PAYG100Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.0.*)*|3nlrca0hphlsq7bl6v99smx10
      PAYG500Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.0.*)*|dlwisgg79vzzo3zeommthp0zv
    7.2.x:
      BYOL: FortiAnalyzer-VM64-AWS *(7.2.*)*|9ipdy7tpkp24kmfsjgfuymny1
      Flex: FortiAnalyzer-VM64-AWS *(7.2.*)*|9ipdy7tpkp24kmfsjgfuymny1
      PAYG2Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.2.*)*|9dtuu71e8jl604ce11efi1mzo
      PAYG10Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.2.*)*|5fjrlla50pzzq1c8064gnm11n
      PAYG30Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.2.*)*|f260v7j9fwdvlcsbnpsjpaozc
      PAYG100Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.2.*)*|3nlrca0hphlsq7bl6v99smx10
      PAYG500Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.2.*)*|dlwisgg79vzzo3zeommthp0zv
    7.4.x:
      BYOL: FortiAnalyzer-VM64-AWS *(7.4.*)*|9ipdy7tpkp24kmfsjgfuymny1
      Flex: FortiAnalyzer-VM64-AWS *(7.4.*)*|9ipdy7tpkp24kmfsjgfuymny1
      PAYG2Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.4.*)*|9dtuu71e8jl604ce11efi1mzo
      PAYG10Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.4.*)*|5fjrlla50pzzq1c8064gnm11n
      PAYG30Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.4.*)*|f260v7j9fwdvlcsbnpsjpaozc
      PAYG100Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.4.*)*|3nlrca0hphlsq7bl6v99smx10
      PAYG500Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.4.*)*|dlwisgg79vzzo3zeommthp0zv
    7.6.x:
      BYOL: FortiAnalyzer-VM64-AWS *(7.6.*)*|9ipdy7tpkp24kmfsjgfuymny1
      PAYG2Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.6.*)*|9dtuu71e8jl604ce11efi1mzo
      PAYG10Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.6.*)*|5fjrlla50pzzq1c8064gnm11n
      PAYG30Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.6.*)*|f260v7j9fwdvlcsbnpsjpaozc
      PAYG100Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.6.*)*|3nlrca0hphlsq7bl6v99smx10
      PAYG500Devices: FortiAnalyzer-VM64-AWSONDEMAND *(7.6.*)*|dlwisgg79vzzo3zeommthp0zv
Conditions: {}
Resources:
  InstanceRole:
    Type: 'AWS::IAM::Role'
    Properties:
      AssumeRolePolicyDocument:
        Version: 2012-10-17
        Statement:
          - Effect: Allow
            Principal:
              Service:
                - ec2.amazonaws.com
            Action:
              - 'sts:AssumeRole'
      Path: /
      Policies:
        - PolicyName: FAZPolicy
          PolicyDocument:
            Version: 2012-10-17
            Statement:
              - Effect: Allow
                Action:
                  - ec2:AssignPrivateIpAddresses
                  - ec2:DescribeSubnets
                  - ec2:DescribeNetworkInterfaces
                  - ec2:DescribeAddresses
                  - ec2:AssociateAddress
                  - ec2:CreateTags
                Resource: '*'

  InstanceProfile:
    Type: 'AWS::IAM::InstanceProfile'
    Properties:
      Path: /
      Roles:
        - !Ref InstanceRole
  FAZSecGrpBase:
    Type: 'AWS::EC2::SecurityGroup'
    Properties:
      VpcId: !Ref ExistingVPCID
      GroupDescription: FAZSecGrp
      SecurityGroupIngress:
        - Description: Allow remote access to FAZ
          IpProtocol: '-1'
          FromPort: 0
          ToPort: 65535
          CidrIp: !Ref CIDRForFAZccess
        - Description: Allow local VPC access to FAZ
          IpProtocol: '-1'
          FromPort: 0
          ToPort: 65535
          CidrIp: !Ref VPCCIDR
  FAZSecGrpFAZRule:
    Type: 'AWS::EC2::SecurityGroupIngress'
    Properties:
      GroupId: !Ref FAZSecGrpBase
      Description: Allow FAZs to access each other
      IpProtocol: '-1'
      FromPort: 0
      ToPort: 65535
      SourceSecurityGroupId: !Ref FAZSecGrpBase
  FAZ:
    Type: 'AWS::EC2::Instance'
    Properties:
      ImageId: !GetAtt RunImageFunction.ami
      InstanceType: !Ref FAZInstanceType
      IamInstanceProfile: !Ref InstanceProfile
      KeyName: !Ref KeyPair
      BlockDeviceMappings:
        - DeviceName: /dev/sda1
          Ebs:
            VolumeType: gp2
            VolumeSize: '5'
            DeleteOnTermination: 'true'
            Encrypted: !Ref EncryptVolumes
        - DeviceName: /dev/sdb
          Ebs:
            VolumeType: gp2
            VolumeSize: '80'
            DeleteOnTermination: 'true'
            Encrypted: !Ref EncryptVolumes
      NetworkInterfaces:
        - NetworkInterfaceId: !Ref FAZENI0
          DeviceIndex: '0'
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - '-FAZ'
      UserData: !Base64 
        'Fn::Join':
          - |+

          - - config system vdom-exception
            - edit 0
            - set object router.static
            - next
            - edit 0
            - set object system.interface
            - end
            - config system global
            - set hostname FAZ
            - end
            - config system interface
            - edit port1
            - set alias public
            - set mode static
            - !Join 
              - ''
              - - 'set ip '
                - !GetAtt 
                  - FAZENI0
                  - PrimaryPrivateIpAddress
                - /
                - !Select 
                  - '1'
                  - !Split 
                    - /
                    - !Ref ExistingSubnetCIDR
            - set allowaccess ping https ssh
            - set mtu-override enable
            - set mtu 9001
            - next
            - end
            - config router static
            - edit 1
            - set device port1
            - !Join 
              - ''
              - - 'set gateway '
                - !Ref PublicSubnetRouterIP
            - next
            - end
            - config firewall policy
            - edit 1
            - set name outbound-all
            - set srcintf port2
            - set dstintf port1
            - set srcaddr all
            - set dstaddr all
            - set action accept
            - set schedule always
            - set service ALL
            - set logtraffic all
            - set nat enable
            - next
            - end
  FAZENI0:
    Type: 'AWS::EC2::NetworkInterface'
    Properties:
      Description: port1
      GroupSet:
        - !Ref FAZSecGrpBase
      SourceDestCheck: false
      SubnetId: !Ref ExistingSubnetID
      Tags:
        - Key: Name
          Value: !Join 
            - ''
            - - !Ref 'AWS::StackName'
              - FAZENI0
        - Key: Interface
          Value: eth0
  ClusterEIP:
    Type: 'AWS::EC2::EIP'
    Properties:
      Domain: vpc
    DependsOn: FAZ
  FAZMgmtEIP:
    Type: 'AWS::EC2::EIP'
    Properties:
      Domain: vpc
    DependsOn: FAZ
  ClusterAEIPASSOCIATION:
    Type: 'AWS::EC2::EIPAssociation'
    Properties:
      AllocationId: !GetAtt 
        - ClusterEIP
        - AllocationId
      NetworkInterfaceId: !Ref FAZENI0
  CloudwatchAlarmFAZ:
    Type: 'AWS::CloudWatch::Alarm'
    Properties:
      ActionsEnabled: true
      AlarmActions:
        - !Join 
          - ''
          - - 'arn:aws:automate:'
            - !Ref 'AWS::Region'
            - ':ec2:recover'
      AlarmDescription: Cloudwatch alarm to monitor instances status
      AlarmName: !Join 
        - ''
        - - !Ref 'AWS::StackName'
          - '-CWAlarmFAZ'
      ComparisonOperator: GreaterThanThreshold
      Dimensions:
        - Name: InstanceId
          Value: !Ref FAZ
      EvaluationPeriods: 3
      MetricName: StatusCheckFailed_System
      Namespace: AWS/EC2
      Period: 300
      Statistic: Minimum
      Threshold: 0
  LambdaRole:
    Type: AWS::IAM::Role
    Properties:
      AssumeRolePolicyDocument:
        Version: '2012-10-17'
        Statement:
          - Effect: Allow
            Principal:
              Service:
                - lambda.amazonaws.com
            Action:
              - sts:AssumeRole
      Path: /
      Policies:
        - PolicyName: S3AccessRole
          PolicyDocument:
            Version: '2012-10-17'
            Statement:
              - Effect: Allow
                Action:
                  - ec2:DescribeImages
                  - s3:PutObject
                Resource: '*'
              - Effect: Allow
                Action:
                  - logs:*
                Resource: '*'
  ImageFunction:
    Type: AWS::Lambda::Function
    Properties:
      Code:
        ZipFile: !Join
          - |+

          - - import boto3
            - import cfnresponse
            - import logging
            - import json
            - logger = logging.getLogger()
            - logger.setLevel(logging.INFO)
            - client = boto3.client('ec2')
            - ''
            - 'def handler(event, context):'
            - '    if event[''RequestType''] == ''Create'':'
            - '        logger.info(''<-- event received: {}''.format(json.dumps(event)))'
            - '        searchString = event[''ResourceProperties''][''SearchString'']'
            - '        productCode =  event[''ResourceProperties''][''ProductCode'']'
            - '    else:'
            - '        responseData = {''msg'':''200''}'
            - '        cfnresponse.send(event, context, cfnresponse.SUCCESS, responseData)'
            - '        return None'
            - ''
            - '    try:'
            - '        resp = client.describe_images('
            - '            Filters=[{''Name'': ''name'', ''Values'': [searchString]}, {''Name'': ''product-code'', ''Values'': [productCode]}],'
            - '            Owners=[''aws-marketplace'']'
            - '        )'
            - '    except Exception as error:'
            - '        logger.error(''<--!! Exception: {}''.format(error))'
            - '        responseData = {''msg'':''Exception: {}''.format(error)}'
            - '        cfnresponse.send(event, context, cfnresponse.FAILED, responseData)'
            - ''
            - '    if resp[''ResponseMetadata''][''HTTPStatusCode''] == 200 and resp[''Images''] != []:'
            - '        ami_dict = {}'
            - '        ami_list = []'
            - '        for entry in resp[''Images'']:'
            - '            key = entry[''CreationDate'']'
            - '            ami_dict[key] = entry[''ImageId'']'
            - '        ami_list = sorted(ami_dict, reverse = True)'
            - '        logger.info(''--> found latest AMI: {}, {}, {} {}''.format(ami_dict[ami_list[0]], ami_list[0], searchString, productCode))'
            - '        responseData = {''ami'': ami_dict[ami_list[0]]}'
            - '        cfnresponse.send(event, context, cfnresponse.SUCCESS, responseData)'
            - '    else:'
            - '        logger.error(''!!--> Unable to find AMI {} {} in describe_images response! {}''.format(searchString, productCode, resp))'
            - '        responseData = {''msg'':''Unable to find AMI {} {} in describe_images response! {}''.format(searchString, productCode,resp)}'
            - '        cfnresponse.send(event, context, cfnresponse.FAILED, responseData)'
            - ''
      Role: !GetAtt LambdaRole.Arn
      Timeout: 120
      Handler: index.handler
      Runtime: python3.9
      MemorySize: 128
  RunImageFunction:
    Type: Custom::ImageFunction
    Properties:
      ServiceToken: !GetAtt ImageFunction.Arn
      SearchString: !Select
        - '0'
        - !Split
          - '|'
          - !FindInMap
            - FortiAnalyzerAMISearchString
            - !Ref FortiAnalyzerVersion
            - !Ref LicenseType
      ProductCode: !Select
        - '1'
        - !Split
          - '|'
          - !FindInMap
            - FortiAnalyzerAMISearchString
            - !Ref FortiAnalyzerVersion
            - !Ref LicenseType
Outputs:
  FAZURL:
    Value: !Join 
      - ''
      - - 'https://'
        - !Ref FAZMgmtEIP
    Description: URL to access FortiAnalyzer
  FAZUsername:
    Value: admin
    Description: Username to access FortiAnalyzer
  FAZPassword:
    Value: !Ref FAZ
    Description: Password to access FortiAnalyzer